Index: /NEMO/trunk/cfgs/ORCA2_ICE_PISCES/EXPREF/context_nemo.xml
===================================================================
--- /NEMO/trunk/cfgs/ORCA2_ICE_PISCES/EXPREF/context_nemo.xml	(revision 10225)
+++ /NEMO/trunk/cfgs/ORCA2_ICE_PISCES/EXPREF/context_nemo.xml	(revision 10226)
@@ -6,23 +6,10 @@
 <context id="nemo">
 <!-- $id$ -->
-    <variable_definition>
-    <!-- Year of time origin for NetCDF files; defaults to 1800 -->
-       <variable id="ref_year" type="int"   > 1800 </variable>
-       <variable id="rau0"     type="float" > 1026.0 </variable>
-       <variable id="cpocean"  type="float" > 3991.86795711963 </variable>
-       <variable id="convSpsu" type="float" > 0.99530670233846  </variable>
-       <variable id="rhoic"    type="float" > 917.0 </variable>
-       <variable id="rhosn"    type="float" > 330.0 </variable>
-       <variable id="missval"  type="float" > 1.e20 </variable>
-    </variable_definition>
 <!-- Fields definition -->
-    <field_definition src="./field_def_nemo-oce.xml"/>    <!--  NEMO ocean dynamics     -->
-    <field_definition src="./field_def_nemo-ice.xml"/>    <!--  NEMO sea-ice model      -->
-    <field_definition src="./field_def_nemo-pisces.xml"/> <!--  NEMO ocean biology      -->
+    <field_definition src="./field_def_nemo-oce.xml"/>   <!--  Ocean biology                     -->
+    <field_definition src="./field_def_nemo-pisces.xml"/>   <!--  Ocean biology                     -->
 
 <!-- Files definition -->
-    <file_definition src="./file_def_nemo-oce.xml"/>     <!--  NEMO ocean dynamics      -->
-    <file_definition src="./file_def_nemo-ice.xml"/>     <!--  NEMO sea-ice model       -->
-    <file_definition src="./file_def_nemo-pisces.xml"/>  <!--  NEMO ocean biology       -->
+    <file_definition src="./file_def_nemo.xml"/>     <!--  NEMO ocean dynamics                     -->
     <!-- 
 ============================================================================================================
@@ -32,13 +19,14 @@
     
     <axis_definition>
-      <axis id="deptht"  long_name="Vertical T levels"  unit="m" positive="down" />
-      <axis id="depthu"  long_name="Vertical U levels"  unit="m" positive="down" />
-      <axis id="depthv"  long_name="Vertical V levels"  unit="m" positive="down" />
-      <axis id="depthw"  long_name="Vertical W levels"  unit="m" positive="down" />
-      <axis id="nfloat"  long_name="Float number"       unit="-"                 />
-      <axis id="icbcla"  long_name="Iceberg class"      unit="1"                 />
-      <axis id="ncatice" long_name="Ice category"       unit="1"                 />
-      <axis id="iax_20C" long_name="20 degC isotherm"   unit="degC"              />
-      <axis id="iax_28C" long_name="28 degC isotherm"   unit="degC"              />
+      <axis id="deptht" long_name="Vertical T levels" unit="m" positive="down" />
+      <axis id="depthu" long_name="Vertical U levels" unit="m" positive="down" />
+      <axis id="depthv" long_name="Vertical V levels" unit="m" positive="down" />
+      <axis id="depthw" long_name="Vertical W levels" unit="m" positive="down" />
+      <axis id="profsed" long_name="Vertical S levels" unit="cm" positive="down" />
+      <axis id="nfloat" long_name="Float number"      unit="-"                 />
+      <axis id="icbcla"  long_name="Iceberg class"      unit="1"               />
+      <axis id="ncatice" long_name="Ice category"       unit="1"               />
+      <axis id="iax_20C" long_name="20 degC isotherm"   unit="degC"            />
+      <axis id="iax_28C" long_name="28 degC isotherm"   unit="degC"            />
     </axis_definition>
  
@@ -46,4 +34,4 @@
   
     <grid_definition src="./grid_def_nemo.xml"/>
-
+    
 </context>
Index: /NEMO/trunk/cfgs/ORCA2_OFF_PISCES/EXPREF/context_nemo.xml
===================================================================
--- /NEMO/trunk/cfgs/ORCA2_OFF_PISCES/EXPREF/context_nemo.xml	(revision 10225)
+++ /NEMO/trunk/cfgs/ORCA2_OFF_PISCES/EXPREF/context_nemo.xml	(revision 10226)
@@ -23,4 +23,5 @@
       <axis id="depthv" long_name="Vertical V levels" unit="m" positive="down" />
       <axis id="depthw" long_name="Vertical W levels" unit="m" positive="down" />
+      <axis id="profsed" long_name="Vertical S levels" unit="cm" positive="down" />
       <axis id="nfloat" long_name="Float number"      unit="-"                 />
       <axis id="icbcla"  long_name="Iceberg class"      unit="1"               />
Index: /NEMO/trunk/cfgs/SHARED/field_def_nemo-pisces.xml
===================================================================
--- /NEMO/trunk/cfgs/SHARED/field_def_nemo-pisces.xml	(revision 10225)
+++ /NEMO/trunk/cfgs/SHARED/field_def_nemo-pisces.xml	(revision 10226)
@@ -115,4 +115,49 @@
 
      </field_group>
+
+     <!-- SEDIMENT variables on T sediment grid  -->
+     <field_group id="sed_T" grid_ref="grid_T_3DS">
+       <field id="SedDIC"          long_name="Dissolved inorganic Concentration"        unit="mmol/m3" />
+       <field id="SedAlkalini"     long_name="Total Alkalinity Concentration"           unit="mmol/m3" />
+       <field id="SedO2"           long_name="Oxygen Concentration"                     unit="mmol/m3" />
+       <field id="SedCaCO3"        long_name="Calcite Concentration"                    unit="%" />
+       <field id="SedPOS"          long_name="Semi-ref POC Concentration"               unit="%" />
+       <field id="SedPOR"          long_name="Refractory POC Concentration"             unit="%" />
+       <field id="SedPO4"          long_name="Phosphate Concentration"                  unit="mmol/m3" />
+       <field id="SedPOC"          long_name="Labile POC Concentration"                 unit="%" />
+       <field id="SedSil"          long_name="Silicate Concentration"                   unit="mmol/m3" />
+       <field id="SedFe2"          long_name="Fe2+ Concentration"                       unit="mmol/m3" />
+       <field id="SedBSi"          long_name="Biogenic Silicate Concentration"          unit="%" />
+       <field id="SedNO3"          long_name="Nitrate Concentration"                    unit="mmol/m3" />
+       <field id="SedNH4"          long_name="Ammonium Concentration"                   unit="mmol/m3" />
+       <field id="SedH2S"          long_name="H2S Concentration"                        unit="mmol/m3" />
+       <field id="SedSO4"          long_name="SO4 Concentration"                        unit="mmol/m3" />
+       <field id="SedClay"         long_name="Clay Concentration"                       unit="%" />
+       <field id="SedFeO"          long_name="Fe(OH)3 Concentration"                    unit="%" />
+       <field id="SedFeS"          long_name="FeS Concentration"                        unit="%" />
+       <field id="SedpH"           long_name="PH"                                       unit="1"          />
+       <field id="SedCO3por"       long_name="Bicarbonates"                             unit="mol/m3" />
+     </field_group>
+
+     <!-- SEDIMENT additional variables on T sediment grid  -->
+     <field_group id="Diag_S" grid_ref="grid_T_2D">
+       <field id="FlxSi"       long_name="Si sediment flux"                        unit="mol/cm2/s"     />
+       <field id="FlxO2"       long_name="O2 sediment flux"                        unit="mol/cm2/s"     />
+       <field id="FlxDIC"      long_name="DIC sediment flux"                       unit="mol/cm2/s"     />
+       <field id="FlxNO3"      long_name="NO3 sediment flux"                       unit="mol/cm2/s"     />
+       <field id="FlxPO4"      long_name="PO4 sediment flux"                       unit="mol/cm2/s"     />
+       <field id="FlxAlkalini" long_name="Alkalinity sediment flux"                unit="mol/cm2/s"     />
+       <field id="FlxNH4"      long_name="Ammonium sediment flux"                  unit="mol/cm2/s"     />
+       <field id="FlxH2S"      long_name="H2S sediment flux"                       unit="mol/cm2/s"     />
+       <field id="FlxSO4"      long_name="SO4 sediment flux"                       unit="mol/cm2/s"     />
+       <field id="FlxFe2"      long_name="Fe2+ sediment flux"                      unit="mol/cm2/s"     />
+       <field id="Flxtot"      long_name="Sediment net burial rate"                unit="cm/s"     />
+       <field id="dzdep"       long_name="Sedimentation rate"                      unit="cm/s"     />
+       <field id="sflxclay"    long_name="Clay sedimentation rate"                 unit="g/m2/s"     />
+       <field id="sflxcal"     long_name="Calcite sedimentation rate"              unit="mol/m2/s"     />
+       <field id="sflxbsi"     long_name="BSi Sedimentation rate"                  unit="mol/m2/s"     />
+       <field id="sflxpoc"     long_name="POC Sedimentation rate"                  unit="mol/m2/s"     />
+       <field id="sflxfeo"     long_name="Fe(OH)3 Sedimentation rate"              unit="mol/m2/s"     />
+</field_group>
 
      <!-- PISCES additional diagnostics on T grid  -->
Index: /NEMO/trunk/cfgs/SHARED/grid_def_nemo.xml
===================================================================
--- /NEMO/trunk/cfgs/SHARED/grid_def_nemo.xml	(revision 10225)
+++ /NEMO/trunk/cfgs/SHARED/grid_def_nemo.xml	(revision 10226)
@@ -15,4 +15,9 @@
          <domain id="grid_T" />
          <axis id="deptht" />
+       </grid>
+        <!--  -->
+       <grid id="grid_T_3DS" >
+         <domain id="grid_T" />
+         <axis id="profsed" />
        </grid>
         <!--  -->
Index: /NEMO/trunk/cfgs/SHARED/namelist_pisces_ref
===================================================================
--- /NEMO/trunk/cfgs/SHARED/namelist_pisces_ref	(revision 10225)
+++ /NEMO/trunk/cfgs/SHARED/namelist_pisces_ref	(revision 10226)
@@ -17,4 +17,5 @@
   ln_p5z    = .false.        !  PISCES QUOTA model used
   ln_ligand = .false.        !  Enable  organic ligands
+  ln_sediment = .false.      !  Enable sediment module
 /
 !-----------------------------------------------------------------------